// Dear emacs, this is -*- c++ -*-
#ifndef TEMPLATEHANDLING_DATAVECTOR_H
#define TEMPLATEHANDLING_DATAVECTOR_H

// System include(s):
#include <vector>

/// Define a helper class
namespace DataVector_detail {
   class NoBase {};
}

/// Class demonstrating the dictionary issue
template< typename TYPE, typename BASE = DataVector_detail::NoBase >
class DataVector {

public:
   /// Default constructor
   DataVector() : m_vec() {}

private:
   /// A simple member
   std::vector< TYPE* > m_vec;

}; // class DataVector

// ROOT include(s):
#include <RootMetaSelection.h>

namespace ROOT { namespace Meta { namespace Selection {

/// Class making ROOT see the DataVector class with a single template parameter
template< class T, class BASE >
class DataVector : KeepFirstTemplateArguments< 1 >,
   SelectNoInstance {

public:
   /// Declare the member variable transient
   ROOT::Meta::Selection::MemberAttributes< kTransient > m_vec;

};

} } }

#endif // TEMPLATEHANDLING_DATAVECTOR_H
